# ../listeners/_entity_output.py

"""Provides a listener manager for entity outputs."""

# =============================================================================
# >> IMPORTS
# =============================================================================
# Source.Python Imports
#   Core
from core import GameConfigObj
from core import PLATFORM
#   Paths
from paths import SP_DATA_PATH
#   Memory
import memory

from memory.hooks import PreHook
from memory.manager import manager
from entities.datamaps import Variant
from entities.helpers import find_output_name
#   Listeners
from _listeners import ListenerManager


# =============================================================================
# >> GLOBAL VARIABLES
# =============================================================================
BaseEntityOutput = manager.create_type_from_dict(
    'BaseEntityOutput', GameConfigObj(
        SP_DATA_PATH / 'entity_output' / 'CBaseEntityOutput.ini'))

try:
    _fire_output = getattr(BaseEntityOutput, 'fire_output', None)
except ValueError:
    # In case the pointer wasn't found
    _fire_output = None
    
on_entity_output_listener_manager = (
    None if _fire_output is None else ListenerManager()
)
